#!/bin/sh

# A quick script to fix MTA configuration setting in 
# mm_cfg.sh
# Usage: fixup_mta.sh /path/to/mm_cfg.py [backup-extension]
# Requirements: coreutils, grep, sed, python

# Some raw shells don't have support for explicit variable declarations
#declare orig bak 

# Same for fancy functions declarations
#function die() {
die() {
    echo "$@" >&2
    exit 1
}

orig=$1
[ -n "$orig" ] || die "usage: $0 /path/to/mm_cfg.py [backup-extension]"
[ -f "$orig" ] || die "unable to find \"$orig\""
bak=$2
[ -n "$bak" ] && bak=".$bak"

#declare pymod pydir curmta
pydir=$(dirname "$orig")
[ -z "$pydir" ] && pydir="."
pymod=$(basename "$orig")
pymod=${pymod%%.py}

# To be substituted...
python_bin="/usr/bin/python2.5"

curmta=$(PYTHONPATH="${PYTHONPATH}:$pydir" "${python_bin}" -c "import $pymod; print $pymod.MTA")
[ $? -eq 0 ] || die "Unable to load current settings"

[ "x$curmta" = "xManual" ] && exit 0

#declare ws0

ws0='[ '$(echo -ne "\t")']*'
sed -e "s/^\(${ws0}MTA${ws0}=.*\)/#\1\x0AMTA='Manual'/" -i"$bak" "$orig"

# Finally grep -q probably isn't as portable as it should be
if ! grep "^${ws0}MTA${ws0}=" "$orig" >/dev/null 2>&1 ; then
    # Should we backup it first? Probably...
    echo "MTA='Manual'" >>"$orig"
fi

